      subroutine comp_frac(nwork, Tc, T_bkgrd, 
     &   pixel_status,  
     &   sfctype, conv_obs_comb, rain_obs, emisIndex, scatIndex)
     
      implicit none
      include 'parameters.inc'
      
      integer     nwork
      logical     app_sfc
      real        Tc(NPIX, MAX_SCANS, NCHAN)
      real        T_bkgrd(NPIX, MAX_SCANS, NCHAN)
      integer*1   sfctype(NPIX, MAX_SCANS)
      integer*2   pixel_status(NPIX, MAX_SCANS)
      real        conv_obs_comb(NPIX, MAX_SCANS)
      real        conv_obs_csi(NPIX, MAX_SCANS)
      real        var_csfrac(NPIX, MAX_SCANS)
      real        CSI, conv_obs, conv_dbase
      real        VM, delta
      real        fmin37e  !(NPIX, MAX_SCANS)
      real        f37emis  !(NPIX, MAX_SCANS)
      real        ftexz    !(NPIX, MAX_SCANS)
      real        fpol(NPIX, MAX_SCANS)
      real        fpol_test(NPIX, MAX_SCANS)
      real        rain_obs(NPIX, MAX_SCANS)
      
      real        emisIndex(NPIX, MAX_SCANS, NEMIS)
      real        scatIndex(NPIX, MAX_SCANS, NSCAT)
      real        chanWgt(NPIX, MAX_SCANS, 8)
      
      real        scat_wgt
      real        VM19, VM37, VM85, delta19, delta37, delta85
      integer     lin, pix, i, j, ii, jj, ch, idx      
      integer     jjj
      real        cwgt
      real        conv_wgt
      
      real        stratpol(NPIX, MAX_SCANS)
      real        a
      real        b
      real        var_Tc85
      real        var_fc
      real        var_cs
      real        pol
      real        conv_obs_pol(NPIX, MAX_SCANS)
      real        var_pol(NPIX, MAX_SCANS)
      real        p85(NPIX, MAX_SCANS)

      real        sum_weight_pol
      real        sum_weight_dist
      real        weight_dist
      real        dist
      real        weight_pol
      real        wgt_csi, wgt_pol

      real        minemis19, lmin19
      real        minemis37, lmin37
      real        minemis85, lmin85
      real        maxscat85, smax85
      integer     nave
      real        depstdthresh 

      a=-0.192
      b=52.4
      var_Tc85=1.
      var_fc=0.1
      
      do lin = 1, nwork
         do pix = 1, NPIX
            conv_obs_comb(pix, lin) = MISS_FLT
            conv_obs_csi(pix, lin) = MISS_FLT
            conv_obs_pol(pix, lin) = MISS_FLT

            if (pixel_status(pix,lin) .lt. 0) goto 10
            
            ! Identify applicable surfaces.
            app_sfc = .FALSE.
            if (sfctype(pix,lin) .EQ. 0) app_sfc = .TRUE. 
            
            ! proceed only with applicable surfaces
            if ( .not. app_sfc ) goto 10
            
            
            VM = 0.
            do i = lin-1, lin+1
               do j = pix-1, pix+1
                  
                  if(i .lt. 1 .or. i .gt. nwork .or.
     &               j .lt. 1       .or. j .gt. NPIX) goto 20
                  if (pixel_status(j, i) .lt. 0) goto 20
                  
                  delta = Tc(pix,lin,6) - Tc(j,i,6)
                     
                  if (delta .lt. VM ) VM = delta
                  
20                continue
               end do
            end do
             
            if(Tc(pix,lin,6) .gt. T_bkgrd(pix,lin,6))then
               CSI = abs(VM)
            else
               CSI = abs(VM) + abs(T_bkgrd(pix,lin,6)-Tc(pix,lin,6))
            endif
               
            if (                    CSI .lt.   0.) 
     &          var_csfrac(pix,lin) = 0.26
            if (CSI .ge.   0. .and. CSI .lt.  20.) 
     &          var_csfrac(pix,lin) = 0.34
            if (CSI .ge.  20. .and. CSI .lt.  40.) 
     &          var_csfrac(pix,lin) = 0.42 
            if (CSI .ge.  40. .and. CSI .lt.  60.) 
     &          var_csfrac(pix,lin) = 0.50 
            if (CSI .ge.  60. .and. CSI .lt.  80.) 
     &          var_csfrac(pix,lin) = 0.50 
            if (CSI .ge.  80. .and. CSI .lt. 100.) 
     &          var_csfrac(pix,lin) = 0.42 
            if (CSI .ge. 100. .and. CSI .lt. 120.) 
     &          var_csfrac(pix,lin) = 0.34 
            if (CSI .ge. 120.                    ) 
     &          var_csfrac(pix,lin) = 0.26 
               
            
            ! from bill's routine
            stratpol(pix,lin)=a*(Tc(pix,lin,6)+Tc(pix,lin,7))/2.+b
            pol=Tc(pix,lin,7)-Tc(pix,lin,6)
            if(stratpol(pix,lin) .gt. 0.) then
               if(pol .lt. 0.) then
                 conv_obs_pol(pix,lin)=1.
               else if(pol .gt. stratpol(pix,lin)) then 
                 conv_obs_pol(pix,lin)=0.
               else
                  p85(pix,lin)=(Tc(pix,lin,7)-Tc(pix,lin,6))/
     +                      stratpol(pix,lin)
                  conv_obs_pol(pix,lin)=1.-p85(pix,lin)
               end if
               var_pol(pix,lin)=(2.*(stratpol(pix,lin)**2)+
     +         a*a*pol*pol/2.)*var_Tc85/(stratpol(pix,lin)**4)+
     +         var_fc
            else
               conv_obs_pol(pix,lin)=0.
               var_pol(pix,lin)=1000.
            end if
            

CCC         ! combine csi and cs_pol            
            call conv_strat(CSI, conv_obs)
            conv_obs_csi(pix, lin) = conv_obs
            
            if(conv_obs.le.0. .and. conv_obs_pol(pix,lin).le.0.)then
               conv_obs_comb(pix, lin) = 0.0
            else
               wgt_csi = 1.0 / var_csfrac(pix, lin)
               if(var_pol(pix,lin) .ne. 0)then
                  wgt_pol = 1.0 / var_pol(pix,lin)
               else
                  wgt_pol = 1.0
                  wgt_csi = 0.0
               endif
               conv_obs_comb(pix, lin) = (conv_obs * wgt_csi + 
     &            conv_obs_pol(pix,lin) * wgt_pol) / (wgt_csi+wgt_pol)
            endif
            
10          continue
             
         end do
      end do  
      
      return
      end
      
      
      subroutine conv_strat(CSI, conv_obs)

      real    CSI
      real    conv_obs
      
c      ! for area (based on SSMI data)
      if(CSI .le. 25.0)then
         conv_obs = 0.
      else if(CSI .ge. 154.0)then
         conv_obs = 1.0
      else
         conv_obs = 0.007752 * (CSI-25.0)
      endif
      
      return
      end
