      ! Fill those internal and retrieval arrays that require default values
      ! Change the missing value of -999. to -9999.9 as required by TSDIS
      ! Ye Hong		6/97 
      ! 05/02  Replaced NBUFF and NCORE with MAX_SCANS  

      subroutine init_arrays(pixel_status, rain_status, frzheight, 
     &			sfcrain, convect, quality, structure, 
     &			clw, rain, ciw, ice, Q1)

      implicit    none
      include     'parameters.inc'

      logical     structure
      integer*2   pixel_status(NPIX, MAX_SCANS)
      integer*2   rain_status(NPIX, MAX_SCANS)
      real        frzheight(NPIX, MAX_SCANS)
      real        sfcrain(NPIX, MAX_SCANS)
      real        convect(NPIX, MAX_SCANS)
      real        quality(NPIX, MAX_SCANS)
      real        clw (NPIX, MAX_SCANS, NLYR)
      real        rain(NPIX, MAX_SCANS, NLYR)
      real        ciw (NPIX, MAX_SCANS, NLYR)
      real        ice (NPIX, MAX_SCANS, NLYR)
      real        Q1 (NPIX, MAX_SCANS, 0:NLYR)

      integer     lin, pix, lyr

      do lin = 1, MAX_SCANS
        do pix = 1, NPIX
          pixel_status(pix,lin)  = 0
          rain_status(pix,lin)   = 0
          frzheight(pix,lin)     = MISS_FLT
          sfcrain(pix,lin)       = MISS_FLT
          convect(pix,lin)       = MISS_FLT
          quality(pix,lin)       = MISS_FLT
          Q1(pix,lin,0)          = MISS_FLT

          if ( structure ) then
            do lyr = 1, NLYR
              clw(pix,lin,lyr)  = MISS_FLT
              rain(pix,lin,lyr) = MISS_FLT
              ciw(pix,lin,lyr)  = MISS_FLT
              ice(pix,lin,lyr)  = MISS_FLT
              Q1(pix,lin,lyr)   = MISS_FLT
            end do
          endif
        end do
      end do

      return
      end

