      ! Write retrieved quantities to output file for analysis.

      subroutine output_debug(nwork, lat, lon, Tb, Tc, stdtime, 
     &	    	sfctype, sfckind, frzheight, pixel_status, rain_status,
     &		sfcrain, quality)

      implicit none

      include 'parameters.inc'


      integer     nwork
      real        lat(NPIX, MAX_SCANS)
      real        lon(NPIX, MAX_SCANS)
      real        Tb (NPIX, MAX_SCANS, NCHAN)
      real        Tc (NPIX, MAX_SCANS, NCHAN)
      integer*2   stdtime(MAX_SCANS, 6)
      integer*1   sfctype(NPIX, MAX_SCANS)
      integer*1   sfckind(NPIX, MAX_SCANS)
      real        frzheight(NPIX, MAX_SCANS) 
      integer*2   pixel_status(NPIX, MAX_SCANS)
      integer*2   rain_status(NPIX, MAX_SCANS)
      real        sfcrain(NPIX, MAX_SCANS)
      real        quality(NPIX, MAX_SCANS)
      real        clw (NPIX, MAX_SCANS, NLYR)
      real        rain(NPIX, MAX_SCANS, NLYR)
      real        ciw (NPIX, MAX_SCANS, NLYR)
      real        ice (NPIX, MAX_SCANS, NLYR)

      integer     lin, pix, lyr, chan, i
c
cejn debug - write a few pixels per scan to an ASCII file
c     open(19,file='ascii_dump.out',status='new')
cend debug

      do lin = 1, nwork
         IF (sfcrain(31,lin) .gt. 0. .or. sfcrain(91,lin) .gt. 0. .or.
     &       sfcrain(151,lin) .gt. 0. ) THEN
         write(19,200) lin 
  200    format('lin # ',i5)
         write(19,201) lat(31,lin), lat(91,lin), lat(151,lin)
  201    format('lat at pix 31/91/151: ',3f8.2)
         write(19,202) lon(31,lin), lon(91,lin), lon(151,lin)
  202    format('lon at pix 31/91/151: ',3f8.2)
         write(19,203) Tb(31,lin,1), Tb(91,lin,1), Tb(151,lin,1)
  203    format('Tb1 at pix 31/91/151: ',3f8.2)
         write(19,204) Tb(31,lin,2), Tb(91,lin,2), Tb(151,lin,2)
  204    format('Tb2 at pix 31/91/151: ',3f8.2)
         write(19,205) Tb(31,lin,3), Tb(91,lin,3), Tb(151,lin,3)
  205    format('Tb3 at pix 31/91/151: ',3f8.2)
         write(19,206) Tb(31,lin,4), Tb(91,lin,4), Tb(151,lin,4)
  206    format('Tb4 at pix 31/91/151: ',3f8.2)
         write(19,207) Tb(31,lin,5), Tb(91,lin,5), Tb(151,lin,5)
  207    format('Tb5 at pix 31/91/151: ',3f8.2)
         write(19,208) Tb(31,lin,6), Tb(91,lin,6), Tb(151,lin,6)
  208    format('Tb6 at pix 31/91/151: ',3f8.2)
         write(19,209) Tb(31,lin,7), Tb(91,lin,7), Tb(151,lin,7)
  209    format('Tb7 at pix 31/91/151: ',3f8.2)
         write(19,210) Tc(31,lin,1), Tc(91,lin,1), Tc(151,lin,1)
  210    format('Tc1 at pix 31/91/151: ',3f8.2)
         write(19,211) Tc(31,lin,2), Tc(91,lin,2), Tc(151,lin,2)
  211    format('Tc2 at pix 31/91/151: ',3f8.2)
         write(19,212) Tc(31,lin,3), Tc(91,lin,3), Tc(151,lin,3)
  212    format('Tc3 at pix 31/91/151: ',3f8.2)
         write(19,213) Tc(31,lin,4), Tc(91,lin,4), Tc(151,lin,4)
  213    format('Tc4 at pix 31/91/151: ',3f8.2)
         write(19,214) Tc(31,lin,5), Tc(91,lin,5), Tc(151,lin,5)
  214    format('Tc5 at pix 31/91/151: ',3f8.2)
         write(19,215) Tc(31,lin,6), Tc(91,lin,6), Tc(151,lin,6)
  215    format('Tc6 at pix 31/91/151: ',3f8.2)
         write(19,216) Tc(31,lin,7), Tc(91,lin,7), Tc(151,lin,7)
  216    format('Tc7 at pix 31/91/151: ',3f8.2)
         write(19,217) sfcrain(31,lin), sfcrain(91,lin),sfcrain(151,lin)
  217    format('rain @ pix 31/91/151: ',3f8.2)
         write(19,*)
         ENDIF
cc       write(9) lin      ! DEBUG
cc       write(9) (lat(pix, lin), pix=1, NPIX)
cc       write(9) (lon(pix, lin), pix=1, NPIX)
cc       write(9) ((Tb(pix, lin, chan), pix=1, NPIX), chan=1, NCHAN)
cc       write(9) ((Tc(pix, lin, chan), pix=1, NPIX), chan=1, NCHAN)
cc       write(9) (stdtime(lin, i), i = 1, 6)
cc       write(9) (sfctype(pix, lin), pix=1, NPIX)
cc       write(9) (sfckind(pix, lin), pix=1, NPIX)
cc       write(9) (frzheight(pix, lin), pix=1, NPIX)
cc       write(9) (pixel_status(pix, lin), pix=1, NPIX)
cc       write(9) (rain_status(pix, lin), pix=1, NPIX)
cc       write(9) (sfcrain(pix, lin), pix=1, NPIX)
cc       write(9) (quality(pix, lin), pix=1, NPIX)
      end do

cejn debug
c     close(19)
cend debug
      return
      end


