      !  Changed to TMI      9/97
      
      !  01/07/98
      !     if ( rms2_min .ge. 1000. ) goto 10 ==>
      !     if ( rms2_min .ge. 10000. ) goto 10 
      !     sfcrain(pix, lin) = ... * adjust where adjust = 1.5
      !  05/02 Replaced NBUFF and NCORE with MAX_SCANS 
      !  06/02 Removed varblty, dbc_Varb
      !        Set adjust = 1.0
      !  11/02 Set pixel_status to invalid surface type and the 
      !        surface rainrate its negative value for ambiguous 
      !        rain retrievals
      !  03/03 Modified the summation of convective rain
      !  05/03 Set adjust to 0.9
      !  09/03 Pixel_status is no longer set to -21 for ambiguous rain_status
      !        All retrieved fields are set to their negative value for
      !          pixels with an ambiguous rain_status     
      !  11/03 Possible ice is no longer a valid surface type
      !        Change the rain/no-rain criteria from the 85/9 H TB to an 
      !          85/9 PCT TB.  Fill in most of the indeterminate screens, 
      !          as they are usually rain.
      !  03/04 All retrieved fields for a pixel with an ambiguous rain_status
      !        are no longer set to their negative value
      !  04/04 Multiply convective rain by the adjustment factor

      !  Routine calculates rainfall and vertical structure over
      !  coast & other surface.  The code reads the profiles and 
      !  associated temperatures from the hydrometeor profile 
      !  database - checks the temperature differences and forms 
      !  a weighted average with the weight derived from a gaussian 
      !  of standard dev. sigma (currently set at 4K)

      subroutine rain_coast(nwork, Tc, sfctype, sfckind, frzheight, 
     &	 	  pixel_status, rain_status, dbc_nprofiles, 
     &	 	  dbc_sfc_code, dbc_cstype, dbc_occur, 
     &	 	  dbc_sfcrain, dbc_convect, dbc_clw, dbc_rain,  
     &	 	  dbc_ciw, dbc_ice, dbc_Q1,  
     &	 	  dbc_Tb, dbc_Tb_cover, sfcrain, convect, 
     &	 	  quality, structure, clw, rain, ciw, ice, Q1)

      implicit none
      include 'parameters.inc'

      integer     nwork
      logical     structure
      real        Tc(NPIX, MAX_SCANS, NCHAN)
      integer*1   sfctype(NPIX, MAX_SCANS)
      integer*1   sfckind(NPIX, MAX_SCANS)
      real        frzheight(NPIX, MAX_SCANS)
      integer*2   pixel_status(NPIX, MAX_SCANS)
      integer*2   rain_status(NPIX, MAX_SCANS)
      integer     dbc_nprofiles(DB_LAND)
      integer     dbc_sfc_code(DB_LAND)
      integer     dbc_cstype(DB_LAND,DBL_MXPROFILE)
      real        dbc_occur(DB_LAND,DBL_MXPROFILE)
      real        dbc_sfcrain(DB_LAND,DBL_MXPROFILE)
      real        dbc_convect(DB_LAND,DBL_MXPROFILE)
      real        dbc_clw(DB_LAND,DBL_MXPROFILE,NLYR)
      real        dbc_rain(DB_LAND,DBL_MXPROFILE,NLYR)
      real        dbc_ciw(DB_LAND,DBL_MXPROFILE,NLYR) 
      real        dbc_ice(DB_LAND,DBL_MXPROFILE,NLYR)
      real        dbc_Q1(DB_LAND,DBL_MXPROFILE,0:NLYR)
      real        dbc_Tb(DB_LAND,DBL_MXPROFILE,DB_NCHAN)
      real        dbc_Tb_cover(DB_LAND,DBL_MXPROFILE,DB_NCHAN)
      real        sfcrain(NPIX, MAX_SCANS) 
      real        convect(NPIX, MAX_SCANS)   
      real        quality(NPIX, MAX_SCANS)
      real        clw(NPIX, MAX_SCANS,NLYR)
      real        rain(NPIX, MAX_SCANS,NLYR)
      real        ciw(NPIX, MAX_SCANS,NLYR) 
      real        ice(NPIX, MAX_SCANS,NLYR)
      real        Q1(NPIX, MAX_SCANS,0:NLYR)

      integer     lin, pix, lyr
      integer     id, prof
      integer     index1, index2
      logical     app_sfc
      real        sigma, sigma2, adjust
      real        wgt_limit, wgt_coef
      real        sumwgt, sumrms, sumsfcrain, sumconvect
      real        sumclw(NLYR), sumrain(NLYR), sumciw(NLYR)
      real        sumice(NLYR), sumQ1(0:NLYR)
      real        d1, d2, d3, d4, d5, d6, d7, d8, d9
      real        rms2, rms2_min, weight, wgt_profile
      real        beta, pct  
  

      adjust = 1.0
      
c     Assign gaussian shape/cutoff constants 
c
      sigma       =  6.
      wgt_limit   = 0.001
      sigma2 = sigma*sigma
      wgt_coef = 0.797884561/sigma
 
c      ! Compute land database freezing height
c      do id = 1, DB_LAND
c        dbc_frzhgt(id) = (dbc_sfc_temp(id)-273.15)/0.0065      
c      end do
c 
      do lin = 1, nwork
         do pix = 1, NPIX

            if (pixel_status(pix,lin) .lt. 0) goto 10

            ! Identify applicable surfaces.

            app_sfc = .FALSE.
            if (sfctype(pix,lin) .EQ. 2) app_sfc = .TRUE. 
 
            ! proceed only with applicable surfaces
            if ( .not. app_sfc ) goto 10

            ! Assign zero rainfall rate and high quality to
            ! pixels which have been previously screened.
            if ( rain_status(pix,lin) .lt. 0 )then
               sfcrain(pix,lin) = 0.
               convect(pix,lin) = 0.
               quality(pix,lin) = 0.0
               Q1(pix,lin,0)    = 0.
               if ( structure ) then
                  do lyr = 1, NLYR
                     clw(pix,lin,lyr)  = 0.
                     rain(pix,lin,lyr) = 0.
                     ciw(pix,lin,lyr)  = 0.
                     ice(pix,lin,lyr)  = 0.
                     Q1(pix,lin,lyr)   = 0.
                  end do
               endif
               goto 10
            endif

            ! Skip retrieval loop if Tbs are too warm.  This step
            ! is applicable because only scattering signature is
            ! currently being used.
c            beta=0.48
c            pct=(beta*Tc(pix,lin,6)-Tc(pix,lin,7))/(beta-1)
c            if(((rain_status(pix,lin).lt.63).or.(rain_status(pix,lin)
c     +        .gt.65)).and.(Tc(pix,lin,3).lt.pct+4.5.and. 
c     +        rain_status(pix,lin).lt.60))then
            if ( Tc(pix,lin,6) .gt. 257. )then
               sfcrain(pix,lin) = 0.
               convect(pix,lin) = 0.
               quality(pix,lin) = 0.
               Q1(pix,lin,0)    = 0.
               if ( structure ) then
                  do lyr = 1, NLYR
                     clw(pix,lin,lyr)  = 0.
                     rain(pix,lin,lyr) = 0.
                     ciw(pix,lin,lyr)  = 0.
                     ice(pix,lin,lyr)  = 0.
                     Q1(pix,lin,lyr)   = 0.
                  end do
               endif
               goto 10
            endif

            ! Proceed with potentially raining pixels
            if (rain_status(pix,lin) .ge. 0) then

               ! Initialize internal sums
               sumwgt     = 0.
               sumrms     = 0.
               sumsfcrain = 0.
               sumconvect = 0.
               sumQ1(0)   = 0.
               if ( structure ) then
                  do lyr = 1, NLYR
                     sumclw(lyr)  = 0.
                     sumrain(lyr) = 0.
                     sumciw(lyr)  = 0.
                     sumice(lyr)  = 0.
                     sumQ1(lyr)   = 0.
                  end do
               endif
               rms2_min  = 10000.

               ! Loop over the profiles in each of the databases
               do id = 1, DB_LAND

                  ! check that database surface is land
                  if (dbc_sfc_code(id) .ne. 1 ) goto 20
c                  ! check that freezing heights are commensurate
c                  delta_frzhgt = dbc_frzhgt(id) - frzheight(pix,lin)
c                  if ( abs(delta_frzhgt) .gt. 3000.) goto 20

                  do prof = 1, dbc_nprofiles(DB_LAND)
c                    if (dbc_cstype(id,prof) .eq.1) then
                     d1 = 0.0*(Tc(pix,lin,1) - dbc_Tb(id,prof,1))
                     d2 = 0.0*(Tc(pix,lin,2) - dbc_Tb(id,prof,2))
                     d3 = 0.0*(Tc(pix,lin,3) - dbc_Tb(id,prof,3))
                     d4 = 0.0*(Tc(pix,lin,4) - dbc_Tb(id,prof,4))
                     d5 = 0.2*(Tc(pix,lin,5) - dbc_Tb(id,prof,5))
                     d6 = 1.0*(Tc(pix,lin,6) - dbc_Tb(id,prof,6))
                     d7 = 1.0*(Tc(pix,lin,7) - dbc_Tb(id,prof,7))
                     rms2 = (d1*d1 + d2*d2 + d3*d3 + d4*d4 + d5*d5 
     &                     + d6*d6 + d7*d7)/3.0

                     ! keep track of smallest rms 
                     if ( rms2 .lt. rms2_min ) then
                        rms2_min = rms2
                        index1 = id
                        index2 = prof
                     endif

                     ! Compute weight assigned to structure
                     weight = wgt_coef*exp(-rms2/(2.*sigma2))
                     if ( weight .ge. wgt_limit ) then
                        wgt_profile = dbc_occur(id,prof)*weight
                        sumwgt = sumwgt + wgt_profile
                        sumrms = sumrms + wgt_profile*sqrt(rms2)
                        sumsfcrain = sumsfcrain + 
     &                               wgt_profile*dbc_sfcrain(id, prof)
                        sumconvect = sumconvect + 
     &                               wgt_profile*dbc_convect(id,prof)
                            sumQ1(0)   = sumQ1(0) + 
     &                               wgt_profile*dbc_Q1(id,prof,0)
                        if ( structure ) then
                           do lyr = 1, NLYR
                              sumclw(lyr)  = sumclw(lyr) + 
     &                               wgt_profile*dbc_clw(id,prof,lyr)
                              sumrain(lyr)  = sumrain(lyr) + 
     &                               wgt_profile*dbc_rain(id,prof,lyr)
                              sumciw(lyr)  = sumciw(lyr) + 
     &                               wgt_profile*dbc_ciw(id,prof,lyr)
                              sumice(lyr)  = sumice(lyr) + 
     &                               wgt_profile*dbc_ice(id,prof,lyr)
                              sumQ1(lyr)   = sumQ1(lyr) + 
     &                               wgt_profile*dbc_Q1(id,prof,lyr)
                           end do
                        endif
                     endif
c                    endif
                  end do
20             end do
 
               ! Normalize output profiles.  If no profiles were
               ! ever examined, rms2_min is not modified and can be
               ! used to skip normalization.
               if ( rms2_min .ge. 10000. ) goto 10
               if ( sumwgt .gt. 0. ) then
                  sfcrain(pix,lin) = sumsfcrain/sumwgt
                  quality(pix,lin) = sumrms/sumwgt
                  Q1(pix,lin,0)    = sumQ1(0)/sumwgt
                  convect(pix,lin) = sumconvect/sumwgt
                  if ( structure ) then
                     do lyr = 1, NLYR
                        clw(pix,lin,lyr)  = sumclw(lyr)/sumwgt
                        rain(pix,lin,lyr) = sumrain(lyr)/sumwgt
                        ciw(pix,lin,lyr)  = sumciw(lyr)/sumwgt
                        ice(pix,lin,lyr)  = sumice(lyr)/sumwgt
                        Q1(pix,lin,lyr)   = sumQ1(lyr)/sumwgt
                     end do
                  endif
               else
                  sfcrain(pix,lin) = dbc_sfcrain(index1,index2)
                  convect(pix,lin) = dbc_convect(index1,index2)
                  quality(pix,lin) = 100.
                  Q1(pix,lin,0)    = dbc_Q1(index1,index2,0)
                  if ( structure ) then
                     do lyr = 1, NLYR
                        clw(pix,lin,lyr)  = dbc_clw(index1,index2,lyr)
                        rain(pix,lin,lyr) = dbc_rain(index1,index2,lyr)
                        ciw(pix,lin,lyr)  = dbc_ciw(index1,index2,lyr)
                        ice(pix,lin,lyr)  = dbc_ice(index1,index2,lyr)
                        Q1(pix,lin,lyr)   = dbc_Q1(index1,index2,lyr)
                     end do
                  endif
               endif
               sfcrain(pix,lin) = sfcrain(pix,lin) * adjust
               convect(pix,lin) = convect(pix,lin) * adjust
            endif   ! end if(rain_status .ge. 0)......
10      continue
c         if(((rain_status(pix,lin) .ge. 63) .and.
c     +      (rain_status(pix,lin) .le. 65)) .and.
c     +      (app_sfc).and.(pixel_status(pix,lin) .ge. 0))then
c           rain_status(pix,lin) = 0
c         end if
       end do
      end do

      return
      end



