      !  assign Q1 = MISS_FLT                               10/99
      !  Replaced NBUFF and NCORE with MAX_SCANS             5/02
      !  Moved calculations of emission and                  6/02
      !  scattering indices out of rain_ocean 
      !  and into their own subroutines. 	             
      !  Removed varblty, ip, ipp, jp, jpp, nch_ssmi,        6/02
      !       dd1_wgt, dd2_wgt, dd3_wgt, dd6_wgt, dd8_wgt,
      !       V_low, V_high
      !  Moved comp_frac out of rain_ocean into retrieval    8/02
      !   5/03 Set pixel_status to invalid surface type and the 
      !        surface rainrate its negative value for ambiguous 
      !        rain retrievals
      !  09/03 Pixel_status is no longer set to -21 for ambiguous rain_status
      !       All retrieved fields are set to their negative value for
      !          pixels with an ambiguous rain_status     
      !  11/03 Reseting retrieved values to 0.0 for sfcrain less
      !          than 1 mm/hr over possible sea ice.  
      !        Sfckind has been added.
      !  03/04 All retrieved fields for a pixel with an ambiguous rain_status
      !        are no longer set to their negative value
      ! Eric Nelkin/SSAI 11/ 3/2011  Move pixel_status "goto 13/10"
      !                              checks after app_sfc assignments;
      !                              avoids checks on uninitialized
      !                              app_sfc
      !
      !  Routine calculates rainfall and vertical structure over
      !  water surface.  The code reads the profiles and associated
      !  temperatures from the hydrometeor profile database - checks
      !  the temperature differences and forms a weighted average
      !  with the weight derived from a gaussian of standard dev.
      !  sigma (currently set at 8K)

      subroutine rain_ocean(nwork, sfctype, sfckind, frzheight, 
     &       pixel_status, rain_status, dbw_nprofiles, 
     &       dbw_sfc_code, dbw_occur, dbw_frzlevel, dbw_rain_cover,
     &       dbw_sfcrain, dbw_convect, dbw_conv_cover, 
     &       dbw_faconvmax, dbw_faconvmean, 
     &       dbw_clw, dbw_rain, dbw_ciw,dbw_ice, dbw_Q1, 
     &       dbw_Tb_cover, dbw_emisIndex, dbw_scatIndex, 
     &       conv_obs, rain_obs, emisIndex, scatIndex,  
     &       sfcrain, convect, quality, 
     &       structure, clw, rain, ciw, ice, Q1)  

      implicit none
      include 'parameters.inc'

      integer     nwork
      logical     structure
      integer*1   sfctype(NPIX, MAX_SCANS)
      integer*1   sfckind(NPIX, MAX_SCANS)
      real        frzheight(NPIX, MAX_SCANS)
      integer*2   pixel_status(NPIX, MAX_SCANS)
      integer*2   rain_status(NPIX, MAX_SCANS)
      integer     dbw_nprofiles(DB_WATER)
      integer     dbw_sfc_code(DB_WATER)
      real        dbw_occur(DB_WATER,DBW_MXPROFILE)
      real        dbw_frzlevel(DB_WATER,DBW_MXPROFILE)
      real        dbw_rain_cover(DB_WATER,DBW_MXPROFILE)
      real        dbw_sfcrain(DB_WATER,DBW_MXPROFILE) 
      real        dbw_convect(DB_WATER,DBW_MXPROFILE)  
      real        dbw_conv_cover(DB_WATER,DBW_MXPROFILE)  
      real        dbw_faconvmax(DB_WATER,DBW_MXPROFILE,NRING)  
      real        dbw_faconvmean(DB_WATER,DBW_MXPROFILE,NRING)  
      real        dbw_clw(DB_WATER,DBW_MXPROFILE,NLYR)
      real        dbw_rain(DB_WATER,DBW_MXPROFILE,NLYR)
      real        dbw_ciw(DB_WATER,DBW_MXPROFILE,NLYR) 
      real        dbw_ice(DB_WATER,DBW_MXPROFILE,NLYR)
      real        dbw_Q1(DB_WATER,DBW_MXPROFILE,0:NLYR)
      real        dbw_Tb_cover(DB_WATER,DBW_MXPROFILE,DB_NCHAN)
      real        dbw_emisIndex(DB_WATER,DBW_MXPROFILE,NEMIS)
      real        dbw_scatIndex(DB_WATER,DBW_MXPROFILE,NSCAT)
      
      real        sfcrain(NPIX, MAX_SCANS)
      real        convect(NPIX, MAX_SCANS)    
      real        quality(NPIX, MAX_SCANS)
      real        clw(NPIX, MAX_SCANS,NLYR)
      real        rain(NPIX, MAX_SCANS,NLYR)
      real        ciw(NPIX, MAX_SCANS,NLYR) 
      real        ice(NPIX, MAX_SCANS,NLYR)
      real        Q1(NPIX, MAX_SCANS,0:NLYR)

      integer     lin, pix, lyr
      integer     id, prof
      integer     index1, index2
      logical     app_sfc
      real        sigma, sigma2
      real        wgt_limit, wgt_coef
      real        sumwgt, sumrms, sumsfcrain, sumconvect
      real        sumclw(NLYR), sumrain(NLYR)
      real        sumciw(NLYR), sumice(NLYR)
      real        sumQ1(0:NLYR)
      real        d1, d2, d3, d4, d5, d6, d7
      real        d1_wgt, d2_wgt, d3_wgt, d4_wgt, d5_wgt
      real        d6_wgt, d7_wgt
      real        sum2d_wgt, max_d, wgt_tb_limit
      real        weight, wgt_profile, min_weight
      real        rms2, rms2_min, rms2_max
      real        delta_frzhgt, delta
      real        dz
      real        wgt_id

      integer     i, j, nch, ii, jj, kk
      real        f
      real        conv_dbase
      real        weight_tb, sum2wgt_ring
      real        dev_ring

      real        conv_obs(NPIX, MAX_SCANS)
      real        rain_obs(NPIX, MAX_SCANS)
      real        emisIndex(NPIX, MAX_SCANS, NEMIS)
      real        scatIndex(NPIX, MAX_SCANS, NSCAT)
      real        chanWgt(NPIX, MAX_SCANS, 7)
       
      real        faconvmax(NRING), faconvmean(NRING)
      real        wgt_ring(NRING)
      integer     factemp(21, 7)
      real        facrain
      real        farain
      real        dbw_farain
      integer     nummean(NRING)
      real        dbw_faconv
      integer     idx,ch
      
      data factemp
     & /4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
     &  4, 4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4,
     &  4, 4, 4, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 4, 4, 4,
     &  4, 4, 4, 3, 3, 3, 2, 2, 2, 2, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 4,
     &  4, 4, 4, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 4, 4, 4,
     &  4, 4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4,
     &  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4/

      real        wgt4chan(7, 11)   

      data        wgt4chan/1.0,  1.0,  1.0, 0.0, 1.0,  1.4, 1.4,
     &                     1.0,  1.0,  1.0, 0.0, 1.0,  1.2, 1.2,
     &                     1.0,  1.0,  1.0, 0.0, 1.0,  1.0, 1.0,
     &                     1.0,  1.0,  1.0, 0.0, 1.0,  0.9, 0.9,
     &                     1.0,  1.0,  1.0, 0.0, 1.0,  0.8, 0.8,
     &                     1.0,  1.0,  1.0, 0.0, 1.0,  0.7, 0.7,
     &                     1.0,  1.0,  1.0, 0.0, 1.0,  0.65, 0.65,
     &                     1.0,  1.0,  1.0, 0.0, 1.0,  0.6, 0.6,
     &                     1.0,  1.0,  1.0, 0.0, 1.0,  0.55, 0.55,
     &                     0.9,  1.0,  1.0, 0.0, 1.0,  0.5, 0.5,
     &                     0.8,  1.0,  1.0, 0.0, 1.0,  0.45, 0.45/

      data        wgt_ring/1., 1., 1., 1./
     
c     Assign gaussian shape/cutoff constants       
      sigma       =  8.0   
      sigma2 = sigma*sigma
      wgt_coef = 0.797884561/sigma
      wgt_limit   = 0.001 
      wgt_tb_limit = wgt_limit
      delta_frzhgt = 300.
      min_weight  = wgt_coef/4.

      ! CK - commented out next 4 lines (8/01)           
c      ! Compute database freezing height
c      do id = 1, DB_WATER
c        dbw_frzhgt(id) = (dbw_sfc_temp(id)-273.15)/0.0065
c      end do
      
c    ! TEST
c      do ch=1,8
c      do idx=1, 11
c        if(ch .ne. 2 .and. ch .ne. 3 .and. ch .ne. 6 .and.
c    &     ch .ne. 7 .and. ch .ne. 8) then 
c          wgt4chan(ch,idx)=0.*wgt4chan(ch,idx)
c        end if
c        if(ch .eq. 8) wgt4chan(ch,idx)=2.*wgt4chan(ch,idx)
c      end do
c      end do
      do lin = 1, nwork
         do pix = 1, NPIX

CC          if (pixel_status(pix,lin) .lt. 0) goto 13

            ! Identify applicable surfaces.
            app_sfc = .FALSE.
            if (sfctype(pix,lin) .EQ. 0) app_sfc = .TRUE.

            ! proceed only with applicable surfaces
            if ( .not. app_sfc .or. pixel_status(pix,lin) .lt.0) goto 13

c           Compute weights
            do ch = 1, 3
               idx = ifix(10 * emisIndex(pix,lin,ch)) + 1
               if(idx .lt. 1)then
                  idx = 1
               else if(idx .gt. 11)then
                  idx = 11
               endif
               chanWgt(pix,lin,ch) = wgt4chan(ch, idx)
            end do

            do ch = 4, 5
               idx = ifix(0.1 * scatIndex(pix, lin, ch-3)) + 1
               if(idx .lt. 1)then
                  idx = 1
               else if(idx .gt. 11)then
                  idx = 11
               endif
               chanWgt(pix,lin,ch) = wgt4chan(ch, idx)
            end do

            do ch = 6, 7
               idx = ifix(10. * conv_obs(pix, lin)) + 1
               if(idx .lt. 1)then
                  idx = 1
               else if(idx .gt. 11)then
                  idx = 11
               endif
               chanWgt(pix,lin,ch) = wgt4chan(ch, idx)
            end do
               chanWgt(pix,lin,6) = 0.5*chanWgt(pix,lin,6)
           
13          continue
            
         end do
      end do      
      do lin = 1, nwork
         do pix = 1, NPIX
CC          if (pixel_status(pix,lin) .lt. 0) goto 10
            
            ! Identify applicable surfaces.
            app_sfc = .FALSE.
            if (sfctype(pix,lin) .EQ. 0) app_sfc = .TRUE. 
            
            ! proceed only with applicable surfaces
            if ( .not. app_sfc .or. pixel_status(pix,lin) .lt.0) goto 10

            ! Assign zero rainfall rate and high quality to
            ! pixels which are not raining.
            if (rain_status(pix,lin) .lt. 0) then
               sfcrain(pix,lin) = 0.0
               convect(pix,lin) = 0.0
               quality(pix,lin) = 0.0
               Q1(pix,lin,0)    = 0.
               if ( structure ) then
                  do lyr = 1, NLYR
                     clw(pix,lin,lyr)  = 0.
                     rain(pix,lin,lyr) = 0.
                     ciw(pix,lin,lyr)  = 0.
                     ice(pix,lin,lyr)  = 0.
                     Q1(pix,lin,lyr)   = 0.
                  end do
               endif
               goto 10
            endif

            ! Proceed with potentially raining pixels
            if (rain_status(pix,lin) .ge. 0) then
            
               ! Initialize internal sums
               sumwgt     = 0.
               sumrms     = 0.
               sumsfcrain = 0.
               sumconvect = 0.
               sumQ1(0)   = 0.
               if ( structure ) then
                  do lyr = 1, NLYR
                     sumclw(lyr)  = 0.
                     sumrain(lyr) = 0.
                     sumciw(lyr)  = 0.
                     sumice(lyr)  = 0.
                     sumQ1(lyr)   = 0.
                  end do
               endif
               rms2_min  = 10000.
               rms2_max  = 0.0

      ! Add searching the max. conv. fraction in concentric rings
               do i = 1, NRING
                  faconvmax(i) = -999.
                  nummean(i) = 0
                  faconvmean(i) = 0.
               end do
               ii = 0
               do i = lin-3, lin+3
                  ii = ii + 1
                  jj = 0
                  do j = pix-3, pix+3
c                  do j = pix-10, pix+10
                     jj = jj + 1
                     if(i .lt. 1 .or. i .gt. nwork .or.
     &                  j .lt. 1 .or. j .gt. NPIX) go to 40
                     if(pixel_status(j, i) .lt. 0) goto 40
                     kk = factemp(jj, ii)
                     if(conv_obs(j,i) .gt. faconvmax(kk))then
                        faconvmax(kk) = conv_obs(j,i)
                     endif
c                     if(conv_obs(j,i) .gt. -990.)then
c                        nummean(kk) = nummean(kk) + 1
c                        faconvmean(kk) = faconvmean(kk) +
c     &                   conv_obs(j,i)
c                     endif
40                   continue
                  end do
               end do
               do i = 1, NRING
                 if(nummean(i) .gt. 0) then
                   faconvmean(i) = faconvmean(i)/float(nummean(i))
                 else
                   faconvmean(i) = -999.
                 end if
               end do
               
               ! get channel weights
               d1_wgt = chanWgt(pix, lin, 1)
               d2_wgt = chanWgt(pix, lin, 2)
               d3_wgt = chanWgt(pix, lin, 3)
               d4_wgt = chanWgt(pix, lin, 4)
               d5_wgt = chanWgt(pix, lin, 5)
               d6_wgt = chanWgt(pix, lin, 6)
               d7_wgt = chanWgt(pix, lin, 7)
               
               sum2d_wgt = d1_wgt*d1_wgt + d2_wgt*d2_wgt + 
     &            d3_wgt*d3_wgt + d4_wgt*d4_wgt + d5_wgt*d5_wgt + 
     &            d6_wgt*d6_wgt + d7_wgt*d7_wgt 
               max_d = sqrt(sum2d_wgt * 2. * sigma2 *
     &                      log(wgt_coef/wgt_tb_limit))
                              
               ! Loop over the profiles in each of the databases
               do id = 1, DB_WATER
                  
                  ! check that database surface is water
                  if (dbw_sfc_code(id) .ne. 0 ) goto 20

                  do prof = 1, dbw_nprofiles(id)
                  
                     ! Check that freezing level of Database profile
                     ! is within 400 m (delta_frzhgt) of the observed.
                     delta = delta_frzhgt
                     
c                     if ( frzheight(pix,lin) .ge. 5200.) 
c     +                                    frzheight(pix,lin) = 5200.
                     if ( frzheight(pix,lin) .le. 1000.) 
     +                                    frzheight(pix,lin) = 1000.
                       
                     ! The following statement is needed because the 
                     ! databse  has no frzlevel between 3800 & 4600 m.
                     if ( frzheight(pix,lin) .gt. 3800.  .and.
     +                      frzheight(pix,lin) .lt. 4600. )
     +                          delta = 2.*delta_frzhgt
                          
                     dz = abs(frzheight(pix,lin) - 
     +                                       dbw_frzlevel(id,prof))
                     ! Gaussian penalty function
                      wgt_id=exp(-dz*dz/(2.*delta*delta))
c
c                    skip rms of Tb computations if wgt_id from 
c                    freezing level = 0.
c                     

                     if (wgt_id .lt. 0.001) goto 25

                     ! Average database Tbs (from raining portion)
                     ! with observed background temps.

                     do nch = 1, NCHAN
                        f = dbw_Tb_cover(id,prof,nch)
c                        dbw_Tbb(id,prof,nch) = f*dbw_Tb(id,prof,nch) +
c     &                                (1.-f)*T_bkgrd(pix,lin,nch)
                     end do

                     d1 = 100.* d1_wgt * (emisIndex(pix,lin,1) - 
     &                                dbw_emisIndex(id,prof,1))
                     d2 = 100.* d2_wgt * (emisIndex(pix,lin,2) - 
     &                                dbw_emisIndex(id,prof,2))
                     d3 = 100.* d3_wgt * (emisIndex(pix,lin,3) - 
     &                                dbw_emisIndex(id,prof,3))
                     
                     d4 = d4_wgt * (scatIndex(pix,lin,1) - 
     &                          dbw_scatIndex(id,prof,1))
                     d5 = d5_wgt * (scatIndex(pix,lin,2) - 
     &                          dbw_scatIndex(id,prof,2))

                     ! cs
                     if(dbw_sfcrain(id,prof) .eq. 0.)then
                        conv_dbase = 0.
                     else
                        conv_dbase = dbw_conv_cover(id,prof)
                     endif

                     d6 = 100.* d6_wgt * (conv_obs(pix,lin) - 
     &                conv_dbase) 

                     ! ring
                     ! based on Bill's result
                     dev_ring = 0.
                     sum2wgt_ring = 0.
                     
c    TEST
                     do i = 1, NRING
c                     do i = 1, 1
                        dbw_faconv = dbw_faconvmax(id, prof,i)
                        if(faconvmax(i) .ge. 0. .and.
     &                     dbw_faconv .ge. 0)then
                           dev_ring = dev_ring + wgt_ring(i)*
     &                        wgt_ring(i)*(faconvmax(i)-dbw_faconv)**2
                           sum2wgt_ring = sum2wgt_ring + wgt_ring(i)**2
                        endif
                     end do
c    TEST
c                    do i = 1, NRING
c                     do i = 1, 1
c                        dbw_faconv = dbw_faconvmean(id, prof,i)
c                        if(faconvmean(i) .ge. 0. .and.
c     &                     dbw_faconv .ge. 0)then
c                           dev_ring = dev_ring + wgt_ring(i)*
c     &                        wgt_ring(i)*(faconvmean(i)-dbw_faconv)**2
c                           sum2wgt_ring = sum2wgt_ring + wgt_ring(i)**2
c                        endif
c                    end do

                     if(sum2wgt_ring .gt. 0.)then
                        dev_ring = dev_ring / sum2wgt_ring
                     endif
                     
                     d7 = 100.* d7_wgt * sqrt(dev_ring)


c                conv_dbase = max(abs(d1), abs(d2), abs(d3), abs(d4), 
c     &                       abs(d5), abs(d6), abs(d7))
 
                     if (max(abs(d1), abs(d2), abs(d3), abs(d4), 
     &                       abs(d5), abs(d6), abs(d7))
     &                                      .lt. max_d) then
                        rms2 = (d1*d1 + d2*d2 + d3*d3 + d4*d4 + d5*d5 + 
     &                          d6*d6 + d7*d7)/sum2d_wgt
                        weight_tb = wgt_coef*exp(-rms2/(2.*sigma2))
                        weight = weight_tb 
                        ! keep track of smallest rms 
                        if ( rms2 .lt. rms2_min ) then
                           rms2_min = rms2
                           index1 = id
                           index2 = prof
                        endif

                        ! Compute weight assigned to structure
                        if ( weight .ge. wgt_limit) then
                           wgt_profile = wgt_id * 
     &                        (dbw_occur(id,prof)) * weight
                           sumwgt = sumwgt + wgt_profile
                           if ( weight .gt. min_weight) then
                             sumrms = sumrms + dbw_occur(id,prof)
                             rms2_max = rms2_max + dbw_occur(id,prof)*
     &                                  dbw_sfcrain(id,prof)
                           end if
                           sumsfcrain = sumsfcrain + 
     &                               wgt_profile*dbw_sfcrain(id, prof)
                           sumconvect = sumconvect +  
     &                               wgt_profile*dbw_convect(id,prof)
                           sumQ1(0) = sumQ1(0) + wgt_profile*
     &                                               dbw_Q1(id,prof,0)
                           if ( structure ) then
                              do lyr = 1, NLYR
                                 sumclw(lyr)  = sumclw(lyr) + 
     &                               wgt_profile*dbw_clw(id,prof,lyr)
                                 sumrain(lyr)  = sumrain(lyr) + 
     &                               wgt_profile*dbw_rain(id,prof,lyr)
                                 sumciw(lyr)  = sumciw(lyr) + 
     &                               wgt_profile*dbw_ciw(id,prof,lyr)
                                 sumice(lyr)  = sumice(lyr) + 
     &                               wgt_profile*dbw_ice(id,prof,lyr)
                                 sumQ1(lyr)  = sumQ1(lyr) +
     &                               wgt_profile*dbw_Q1(id,prof,lyr)
                              end do
                           endif
                        endif ! end if(weight....
                     endif    ! end if(max(d1)....
 25               end do
 20            end do
 
               ! Normalize output profiles.  If no profiles were
               ! ever examined, rms2_min is not modified and can be
               ! used to skip normalization.
               if ( rms2_min .ge. 10000. )goto 10
               if ( sumwgt .gt. 0. ) then
                  sfcrain(pix,lin) = sumsfcrain/sumwgt
                  quality(pix,lin) = sumrms
                  convect(pix,lin) = sumconvect/sumwgt
                  Q1(pix,lin,0)    = sumQ1(0)/sumwgt
                  if ( structure ) then
                     do lyr = 1, NLYR
                        clw(pix,lin,lyr)  = sumclw(lyr)/sumwgt
                        rain(pix,lin,lyr) = sumrain(lyr)/sumwgt
                        ciw(pix,lin,lyr)  = sumciw(lyr)/sumwgt
                        ice(pix,lin,lyr)  = sumice(lyr)/sumwgt
                        Q1(pix,lin,lyr)   = sumQ1(lyr)/sumwgt
                     end do
                  endif
               else
                  sfcrain(pix,lin) = dbw_sfcrain(index1,index2)
                  convect(pix,lin) = dbw_convect(index1,index2)
                  quality(pix,lin) = 0.
                  Q1(pix,lin,0)    = dbw_Q1(index1,index2,0)
                  if ( structure ) then
                     do lyr = 1, NLYR
                        clw(pix,lin,lyr)  = dbw_clw(index1,index2,lyr)
                        rain(pix,lin,lyr) = dbw_rain(index1,index2,lyr)
                        ciw(pix,lin,lyr)  = dbw_ciw(index1,index2,lyr)
                        ice(pix,lin,lyr)  = dbw_ice(index1,index2,lyr)
                        Q1(pix,lin,lyr)   = dbw_Q1(index1,index2,lyr)
                     end do
                  endif
               endif
               if( structure .and. sfcrain(pix,lin) .lt. 0.1) then
                 Q1(pix,lin,0)    = 0.
                 do lyr = 1, NLYR
                   Q1(pix,lin,lyr)    = 0.
                 end do
               end if

            endif  !end if (rain_status .ge. 0)
10      continue
c
c Cut off rain over possible ice below 1 mm/hr
c
         if((sfcrain(pix,lin) .lt. 1.0) .and.
     +      (app_sfc).and.((sfckind(pix,lin) .eq. 4) .or.
     +      (sfckind(pix,lin) .eq. 13)))then
            sfcrain(pix,lin)=0.0
            convect(pix,lin)=0.0
            quality(pix,lin) = 0.0
            Q1(pix,lin,0)    = 0.0
            if ( structure ) then
               do lyr = 1, NLYR
                  clw(pix,lin,lyr)  = 0.0
                  rain(pix,lin,lyr) = 0.0
                  ciw(pix,lin,lyr)  = 0.0
                  ice(pix,lin,lyr)  = 0.0
                  Q1(pix,lin,lyr)   = 0.0
               end do
            endif
         end if
       end do
      end do
      close(10)      
      return
      end
      
      
      
      
