      ! Modified from TMI to SSM/I                         2/1999 
      ! Added dbc                                          8/1999
      ! Comment out writing sfc_code, sfc_temp, # profiles 5/2000
      ! Added TSDIS error codes                           10/2002
      ! modified land part and add elev part, V6           2/2004
      ! Added TSDIS error codes for closing files          3/2004
      ! Upgrade to TRMM V7 TK header file                 10/2011
      ! Pass in cjobid, for error conditions              10/2011
      ! Non-PPS version for Bob Joyce                      9/2012

      subroutine read_dbase(cjobid, sfmask1, sfmask2,  
     &  sstdata, flttw_tab, dbw_nprofiles, dbw_sfc_code, dbw_lyrhgt,  
     &  dbw_occur, dbw_frzlevel, dbw_sfcrain, dbw_convect, 
     &  dbw_rain_cover, dbw_conv_cover, dbw_faconvmax, 
     &  dbw_faconvmean,  
     &  dbw_clw, dbw_rain, dbw_ciw, dbw_ice, dbw_Q1, dbw_Tb, 
     &  dbw_Tbclr, dbw_Tb_cover, elev, dbl_nprofiles, 
     &  dbl_sfc_code, dbl_lyrhgt, dbl_cstype, dbl_occur, 
     &  dbl_sfcrain, dbl_convect, dbl_rain_cover, dbl_conv_cover, 
     &  dbl_clw, dbl_rain, dbl_ciw, dbl_ice, dbl_Q1, 
     &  dbl_Tb, dbl_Tb_cover, dbc_nprofiles, 
     &  dbc_sfc_code, dbc_lyrhgt, dbc_cstype, dbc_occur, 
     &  dbc_sfcrain, dbc_convect, dbc_rain_cover, dbc_conv_cover, 
     &  dbc_clw, dbc_rain, dbc_ciw, dbc_ice, dbc_Q1, 
     &  dbc_Tb, dbc_Tb_cover)

      implicit none           ! Remove at own risk!

C ---------- Variable Declarations ----------

C
      include 'parameters.inc'

      ! File I/O error check variables
      integer*4    iostat, status, db_lun
      character*256 cjobid

      ! Database variables
      character    fname_Wdbase(DB_WATER)*70
      character    fname_Ldbase(DB_land)*70
      integer*1    sfmask1(1440, 720)
      integer*1    sfmask2(1440, 720)
      integer*2    sstdata(0:143,0:90,12)
      real         flttw_tab(131, 131)
      integer*1    elev(4320,2160)

      ! Rainfall profile database variables
      integer      id, i, j, k, n, ilat, ilon

      integer      dbw_nprofiles(DB_WATER)
      integer      dbw_sfc_code(DB_WATER)
      real         dbw_lyrhgt(DB_WATER,NLYR)
      real         dbw_lyrhgtQ1(NLYR)
      real         dbw_occur(DB_WATER,DBW_MXPROFILE)
      real         dbw_frzlevel(DB_WATER,DBW_MXPROFILE)
      real         dbw_Sfcwind			!(DB_WATER,DBW_MXPROFILE)
      real         dbw_sfcrain(DB_WATER,DBW_MXPROFILE)
      real         dbw_convect(DB_WATER,DBW_MXPROFILE)
      real         dbw_rain_cover(DB_WATER,DBW_MXPROFILE)
      real         dbw_conv_cover(DB_WATER,DBW_MXPROFILE)
      real         dbw_faconvmax(DB_WATER,DBW_MXPROFILE,NRING)
      real         dbw_faconvmean(DB_WATER,DBW_MXPROFILE,NRING)
      real         dbw_clw(DB_WATER,DBW_MXPROFILE,NLYR)
      real         dbw_rain(DB_WATER,DBW_MXPROFILE,NLYR)
      real         dbw_ciw(DB_WATER,DBW_MXPROFILE,NLYR)
      real         dbw_ice(DB_WATER,DBW_MXPROFILE,NLYR)
      real         dbw_Q1(DB_WATER,DBW_MXPROFILE,0:NLYR)
      real         dbw_Q2(DB_WATER,DBW_MXPROFILE,0:NLYR)
      real         dbw_Q1_c(DB_WATER,DBW_MXPROFILE,0:NLYR)
      real         dbw_Q2_c(DB_WATER,DBW_MXPROFILE,0:NLYR)
      real         dbw_Tb(DB_WATER,DBW_MXPROFILE,DB_NCHAN)
      real         dbw_Tbclr(DB_WATER,DBW_MXPROFILE,DB_NCHAN)
      real         dbw_Tb_cover(DB_WATER,DBW_MXPROFILE,DB_NCHAN)

      integer      dbl_nprofiles(DB_land)
      integer      dbl_sfc_code(DB_land)
      real         dbl_lyrhgt(DB_land,NLYR)
      real         dbl_lyrhgtQ1(NLYR)	 	!(DB_land,NLYR)
      integer      dbl_cstype(DB_land,DBL_MXPROFILE)
      real         dbl_occur(DB_land,DBL_MXPROFILE)
      real         dbl_frzlevel(DB_land,DBL_MXPROFILE)
      real         dbl_Sfcwind(DB_land,DBL_MXPROFILE)
      real         dbl_sfcrain(DB_land,DBL_MXPROFILE)
      real         dbl_convect(DB_land,DBL_MXPROFILE)
      real         dbl_rain_cover(DB_land,DBL_MXPROFILE)
      real         dbl_conv_cover(DB_land,DBL_MXPROFILE)
      real         dbl_faconvect(DB_land,DBL_MXPROFILE,NRING)
      real         dbl_clw(DB_land,DBL_MXPROFILE,NLYR)
      real         dbl_rain(DB_land,DBL_MXPROFILE,NLYR)
      real         dbl_ciw(DB_land,DBL_MXPROFILE,NLYR)
      real         dbl_snow(NLYR) 		!(DB_land,DBL_MXPROFILE,NLYR)
      real         dbl_graupel(NLYR) 		!(DB_land,DBL_MXPROFILE,NLYR)
      real         dbl_ice(DB_land,DBL_MXPROFILE,NLYR)
      real         dbl_w(0:NLYR) 		!(DB_land,DBL_MXPROFILE,0:NLYR)
      real         dbl_Q1(DB_land,DBL_MXPROFILE,0:NLYR)
      real         dbl_Q2(DB_land,DBL_MXPROFILE,0:NLYR)
      real         dbl_Q1_c(DB_land,DBL_MXPROFILE,0:NLYR)
      real         dbl_Q2_c(DB_land,DBL_MXPROFILE,0:NLYR)
      real         dbl_Tb(DB_land,DBL_MXPROFILE,DB_NCHAN)
      real         dbl_Tbclr(DB_land,DBL_MXPROFILE,DB_NCHAN)
      real         dbl_Tb_cover(DB_land,DBL_MXPROFILE,DB_NCHAN)

      integer      dbc_nprofiles(DB_land)
      integer      dbc_sfc_code(DB_land)
      real         dbc_lyrhgt(DB_land,NLYR)
      real         dbc_lyrhgtQ1(NLYR)	 	!(DB_land,NLYR)
      integer      dbc_cstype(DB_land,DBL_MXPROFILE)
      real         dbc_occur(DB_land,DBL_MXPROFILE)
      real         dbc_frzlevel(DB_land,DBL_MXPROFILE)
      real         dbc_Sfcwind(DB_land,DBL_MXPROFILE)
      real         dbc_sfcrain(DB_land,DBL_MXPROFILE)
      real         dbc_convect(DB_land,DBL_MXPROFILE)
      real         dbc_rain_cover(DB_land,DBL_MXPROFILE)
      real         dbc_conv_cover(DB_land,DBL_MXPROFILE)
      real         dbc_faconvect(DB_land,DBL_MXPROFILE,NRING)
      real         dbc_clw(DB_land,DBL_MXPROFILE,NLYR)
      real         dbc_rain(DB_land,DBL_MXPROFILE,NLYR)
      real         dbc_ciw(DB_land,DBL_MXPROFILE,NLYR)
      real         dbc_snow(NLYR) 		!(DB_land,DBL_MXPROFILE,NLYR)
      real         dbc_graupel(NLYR) 		!(DB_land,DBL_MXPROFILE,NLYR)
      real         dbc_ice(DB_land,DBL_MXPROFILE,NLYR)
      real         dbc_w(0:NLYR) 		!(DB_land,DBL_MXPROFILE,0:NLYR)
      real         dbc_Q1(DB_land,DBL_MXPROFILE,0:NLYR)
      real         dbc_Q2(DB_land,DBL_MXPROFILE,0:NLYR)
      real         dbc_Q1_c(DB_land,DBL_MXPROFILE,0:NLYR)
      real         dbc_Q2_c(DB_land,DBL_MXPROFILE,0:NLYR)
      real         dbc_Tb(DB_land,DBL_MXPROFILE,DB_NCHAN)
      real         dbc_Tbclr(DB_land,DBL_MXPROFILE,DB_NCHAN)
      real         dbc_Tb_cover(DB_land,DBL_MXPROFILE,DB_NCHAN)

C ---------- Read databases into memory ----------
      
      ! Read 0.25 deg. sfc type database
      open(unit = 21, file = DBPATH//'Sfctype93.dbase.asc',
     &     form = 'formatted', err = 1020)
      read(21, FMT=*, err = 1021) ((sfmask1(i,j), i = 1, 1440),
     &     j = 1, 720)
      read(21, FMT=*, err = 1021) ((sfmask2(i,j), i = 1, 1440), 
     &     j = 1, 720)
      close(21, err = 1022)

      ! Read 0.5 deg. climate sst database
      open(unit = 21, err = 1030, file = DBPATH//'Clim-sst.dbase.asc',
     &     status = 'old', form = 'formatted')
      read(21, FMT=*, err = 1031) sstdata
      close(21, err = 1032)

      ! Read Wilheit-Chang freezing level database
       open(unit = 21, err = 1040, file = DBPATH//'Wilheit.dbase.asc',
     &     status = 'old', form = 'formatted')
      read(21, FMT=*, err = 1041) flttw_tab
      close(21, err = 1042)

      ! Read 1/12 degree elevation database
      open(unit = 21, err = 1050, file = DBPATH//'elev.dbase.asc',
     &     status = 'old', form = 'formatted')
      read(21, FMT=*, err = 1051) elev
      close(21, err = 1052)

      fname_Wdbase(1) = DBPATH//
     &   'rainstructures_ocean.rdc.dbase'

      db_lun = 25
      do id = 1, DB_WATER
         open(unit = db_lun, err = 1060, file = fname_Wdbase(id),
     &      status = 'old', form = 'formatted')
         read(db_lun,160, err = 1061) 
         read(db_lun,161, err = 1061) dbw_nprofiles(id)
         read(db_lun,171, err = 1061) dbw_sfc_code(id)
         read(db_lun,173, err = 1061) (dbw_lyrhgt(id,k), k = 1, NLYR)
         read(db_lun,173, err = 1061) (dbw_lyrhgtQ1(k), k = 1, NLYR)
C        write(*,*) dbw_sfc_code(id),
C    &                        dbw_sfc_temp(id),dbw_nprofiles(id)
         do i = 1, dbw_nprofiles(id)
            read(db_lun,174, err = 1061) dbw_occur(id,i),
     &         dbw_frzlevel(id,i), dbw_sfcrain(id,i), 
     &         dbw_convect(id,i), dbw_rain_cover(id,i)
            read(db_lun,175, err = 1061) dbw_conv_cover(id,i),
     &        (dbw_faconvmax(id,i,n), n=1,NRING)
            read(db_lun,175, err = 1061) dbw_conv_cover(id,i),
     &        (dbw_faconvmean(id,i,n), n=1,NRING)
            read(db_lun,176, err = 1061) dbw_Sfcwind
            read(db_lun,180, err = 1061) dbw_Q1(id,i,0), dbw_Q2(id,i,0),
     &         dbw_Q1_c(id,i,0), dbw_Q2_c(id,i,0)
            do k = 1, NLYR
              read(db_lun,177, err = 1061) dbw_clw(id,i,k), 
     &           dbw_rain(id,i,k), dbw_ciw(id,i,k), dbw_ice(id,i,k),
     &           dbw_Q1(id,i,k), dbw_Q2(id,i,k),
     &           dbw_Q1_c(id,i,k), dbw_Q2_c(id,i,k)
            end do
            read(db_lun,178, err = 1061) (dbw_Tb(id,i,n), 
     &         n = 1, DB_NCHAN)
            read(db_lun,178, err = 1061) (dbw_Tbclr(id,i,n), 
     &         n = 1, DB_NCHAN)
            read(db_lun,179, err = 1061) (dbw_Tb_cover(id,i,n), 
     &         n = 1, DB_NCHAN)
         end do
         close(db_lun, err=1062)
      end do
c
      fname_Ldbase(1) = DBPATH//
     &    'rainstructures_land.rdc.dbase'
      db_lun = 35
      do id = 1, DB_land
         open(unit = db_lun, err = 1070, file = fname_Ldbase(id),
     &       status = 'old', form = 'formatted')
        ! Skip descriptive file header information
         read(db_lun,160, err = 1071)
        ! Read the data 
         read(db_lun,161, err = 1071) dbl_nprofiles(id) ! Total # of profiles
         read(db_lun,171, err = 1071) dbl_sfc_code(id)
C         write(*,*) dbl_sfc_code(id), dbl_nprofiles(id)
         read(db_lun,173, err = 1071) (dbl_lyrhgt(id,k), k = 1, NLYR)
         read(db_lun,173, err = 1071) (dbl_lyrhgtQ1(k), k = 1, NLYR)

         do i = 1, dbl_nprofiles(id)
           read(db_lun,171, err = 1071) dbl_cstype(id,i)
           read(db_lun,183, err = 1071) dbl_occur(id,i),
     &          dbl_frzlevel(id,i), dbl_sfcrain(id,i),
     &          dbl_convect(id,i), dbl_rain_cover(id,i)
           read(db_lun,175, err = 1071) dbl_conv_cover(id,i), 
     &         (dbl_faconvect(id,i,n), n=1,NRING)
           read(db_lun,176, err = 1071) dbl_Sfcwind(id,i)
           read(db_lun,182, err = 1071) dbl_w(0), dbl_Q1(id,i,0), 
     &          dbl_Q2(id,i,0), dbl_Q1_c(id,i,0), dbl_Q2_c(id,i,0)
           do k = 1, NLYR
             read(db_lun,181, err = 1071) dbl_clw(id,i,k),
     &            dbl_rain(id,i,k), dbl_ciw(id,i,k), dbl_snow(k), 
     &            dbl_graupel(k), dbl_ice(id,i,k),
     &            dbl_w(k), dbl_Q1(id,i,k), dbl_Q2(id,i,k),
     &            dbl_Q1_c(id,i,k), dbl_Q2_c(id,i,k)
           end do
           read(db_lun,178, err = 1071)
     &            (dbl_Tb(id,i,n), n = 1, DB_NCHAN)
           read(db_lun,178, err = 1071)
     &            (dbl_Tbclr(id,i,n), n = 1, DB_NCHAN)
           read(db_lun,179, err = 1071)
     &            (dbl_Tb_cover(id,i,n), n = 1, DB_NCHAN)
         end do
         close(db_lun, err=1072)
      end do
c
      fname_Ldbase(1) = DBPATH//
     &    'rainstructures_coast.rdc.dbase'
      db_lun = 35
      do id = 1, DB_land
         open(unit = db_lun, err = 1080, file = fname_Ldbase(id),
     &       status = 'old', form = 'formatted')
        ! Skip descriptive file header information
         read(db_lun,160, err = 1081)
        ! Read the data 
         read(db_lun,161, err = 1081) dbc_nprofiles(id) ! Total # of profiles
         read(db_lun,171, err = 1081) dbc_sfc_code(id)
c        write(*,*) dbc_sfc_code(id), dbc_nprofiles(id)
         read(db_lun,173, err = 1081) (dbc_lyrhgt(id,k), k = 1, NLYR)
         read(db_lun,173, err = 1081) (dbc_lyrhgtQ1(k), k = 1, NLYR)

         do i = 1, dbc_nprofiles(id)
           read(db_lun,171, err = 1081) dbc_cstype(id,i)
           read(db_lun,183, err = 1081) dbc_occur(id,i),
     &          dbc_frzlevel(id,i), dbc_sfcrain(id,i),
     &          dbc_convect(id,i), dbc_rain_cover(id,i)
           read(db_lun,175, err = 1081) dbc_conv_cover(id,i), 
     &         (dbc_faconvect(id,i,n), n=1,NRING)
           read(db_lun,176, err = 1081) dbc_Sfcwind(id,i)
           read(db_lun,182, err = 1081) dbc_w(0), dbc_Q1(id,i,0), 
     &          dbc_Q2(id,i,0), dbc_Q1_c(id,i,0), dbc_Q2_c(id,i,0)
           do k = 1, NLYR
             read(db_lun,181, err = 1081) dbc_clw(id,i,k),
     &            dbc_rain(id,i,k), dbc_ciw(id,i,k), dbc_snow(k), 
     &            dbc_graupel(k), dbc_ice(id,i,k),
     &            dbc_w(k), dbc_Q1(id,i,k), dbc_Q2(id,i,k),
     &            dbc_Q1_c(id,i,k), dbc_Q2_c(id,i,k)
           end do
           read(db_lun,178, err = 1081)
     &            (dbc_Tb(id,i,n), n = 1, DB_NCHAN)
           read(db_lun,178, err = 1081)
     &            (dbc_Tbclr(id,i,n), n = 1, DB_NCHAN)
           read(db_lun,179, err = 1081)
     &            (dbc_Tb_cover(id,i,n), n = 1, DB_NCHAN)
         end do
         close(db_lun, err=1082)
      end do

  160 format(///////////////)
  161 format(2x,i6)
  162 format(2x,i6,' profiles')
  171 format(2x,i1)
  172 format(f4.0)
  173 format(14f5.1)  
  174 format(f10.2,f7.0,2f11.6,2x,f8.6) 
  175 format(2x,f9.6,2x,4f9.6) 
  176 format(2x,f7.3,f11.6) 
  177 format(8f11.6)
  178 format(9f7.2)
  179 format(9f7.4)
  180 format(4f11.6)
  181 format(11f11.6)
  182 format(5f11.6)
  183 format(f7.2,f7.0,2f11.6,2x,f8.6)

C     write(*,*) ' '
C     write(*,*) ' Done reading data bases '
      return

      ! Report opening/reading data file errors
 1020 WRITE(*,*) 'Error opening surface type database file; exiting'
      STOP
 1021 WRITE(*,*) 'Error reading surface type database file; exiting'
      STOP
 1022 WRITE(*,*) 'Error closing surface type database file; exiting'
      STOP
 1030 WRITE(*,*) 'Error opening climsst database file; exiting'
      STOP
 1031 WRITE(*,*) 'Error reading climsst database file; exiting'
      STOP
 1032 WRITE(*,*) 'Error closing climsst database file; exiting'
      STOP
 1040 WRITE(*,*) 'Error opening freezing level database file; exiting'
      STOP
 1041 WRITE(*,*) 'Error reading freezing level database file; exiting'
      STOP
 1042 WRITE(*,*) 'Error closing freezing level database file; exiting'
      STOP
 1050 WRITE(*,*) 'Error opening elevation database file; exiting'
      STOP
 1051 WRITE(*,*) 'Error reading elevation database file; exiting'
      STOP
 1052 WRITE(*,*) 'Error closing elevation database file; exiting'
      STOP

 1060 WRITE(*,*) 'Error opening ocean database file; exiting'
      STOP
 1061 WRITE(*,*) 'Error reading ocean database file; exiting'
      STOP
 1062 WRITE(*,*) 'Error closing ocean database file; exiting'
      STOP

 1070 WRITE(*,*) 'Error opening land database file; exiting'
      STOP
 1071 WRITE(*,*) 'Error reading land database file; exiting'
      STOP
 1072 WRITE(*,*) 'Error closing land database file; exiting'
      STOP

 1080 WRITE(*,*) 'Error opening coast database file; exiting'
      STOP
 1081 WRITE(*,*) 'Error reading coast database file; exiting'
      STOP
 1082 WRITE(*,*) 'Error closing coast database file; exiting'
      STOP

      return
      end
